// Texturing - the VERY basics 

#ifdef WIN32

#include "windows.h"

#else

#define WORD unsigned short
#define DWORD unsigned long
#define LONG long
typedef struct tagBITMAPFILEHEADER {
	WORD bfType; 
	DWORD bfSize; 
	WORD bfReserved1; 
	WORD bfReserved2; 
	DWORD bfOffBits; 
} BITMAPFILEHEADER; 

typedef struct tagBITMAPINFOHEADER { 
	DWORD biSize; 
	LONG biWidth; 
	LONG biHeight; 
	WORD biPlanes; 
	WORD biBitCount;
	DWORD biCompression; 
	DWORD biSizeImage; 
	LONG biXPelsPerMeter; 
	LONG biYPelsPerMeter; 
	DWORD biClrUsed; 
	DWORD biClrImportant; 
} BITMAPINFOHEADER; 

#endif

#if __APPLE__

#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include <GLUT/glut.h>
unsigned long pc2mac(unsigned long a){
	unsigned long b;
	b=   (a & (0x000000ff)) << 24;
	b |=( a & (0x0000ff00)) << 8 ;
	b |= (a & (0x00ff0000)) >> 8 ;
	b |= (a & (0xff000000)) >> 24 ;
	return b;
}

#else

#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>

#endif

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

unsigned char *LoadBmp(char *fn, int *wi, int *hi);
void Init(void);

GLuint nTexture;

void display(void) {
  GLUquadricObj* pObj;
  // Set up OpenGL state.
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHT_MODEL_TWO_SIDE);
  glLoadIdentity();
  glTranslatef(0.0,0.0,-10.0);
  pObj = gluNewQuadric();
  gluQuadricTexture(pObj,GL_TRUE);

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, nTexture);
  gluSphere(pObj, 3.0, 50, 50);
  glDisable(GL_TEXTURE_2D);


  gluDeleteQuadric(pObj);
  glutSwapBuffers();
}

void reshape(int w, int h){
    GLfloat fAspect;
    if(h == 0) h = 1;
    glViewport(0, 0, w, h);
    fAspect = (GLfloat)w/(GLfloat)h;
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0f, fAspect, 1.0, 25.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}


void Init(void){
 unsigned char *pix;
 int w,h;
 glEnable(GL_TEXTURE_2D);
 pix=LoadBmp("picture.bmp",&w,&h);	
 glGenTextures(1, &nTexture);
 glBindTexture(GL_TEXTURE_2D, nTexture);
 glTexImage2D(	GL_TEXTURE_2D, 0, GL_RGB, w, h,
 				0, GL_RGB, GL_UNSIGNED_BYTE, pix);
 glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
 free(pix);
 glDisable(GL_TEXTURE_2D);
}

int main(int argc, char* argv[]) {
  int window_id;
  glutInit(&argc, argv);

  glutInitWindowSize( 640, 480 );
  glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH );
  window_id = glutCreateWindow( "Framework" );
  glutSetWindow( window_id );

  // set up GLUT callback functions
  glutDisplayFunc(display);
  glutIdleFunc(display);
  glutReshapeFunc(reshape);
  // in a full application these should be used
  //glutKeyboardFunc(Keyboard);
  //glutMotionFunc(motion);
  //glutMouseFunc(mouse);

  // Start gluts mainloop.
  Init();
  glutMainLoop();
}

unsigned short readShortInt(FILE *f){
	unsigned short b=0;
	unsigned char a1,a2;
	fread(&a1,1,1,f);
	fread(&a2,1,1,f);
	b=(unsigned short)(a1);
	b |= (((unsigned short)a2) << 8);
	printf("si=%d\n",b);
	return b;
}
unsigned long readLongInt(FILE *f){
	unsigned long b;
	unsigned char a1,a2,a3,a4;
	fread(&a1,1,1,f);
	fread(&a2,1,1,f);
	fread(&a3,1,1,f);
	fread(&a4,1,1,f);
	b=   (unsigned long)a1;
	b |= (((unsigned long)a2) << 8);
	b |= (((unsigned long)a3) << 16);
	b |= (((unsigned long)a4) << 24);
	printf("l=%ld\n",b);
	return b;
}


unsigned char *LoadBmp(char *fn, int *wi, int *hi){
 BITMAPFILEHEADER bmfh;
 BITMAPINFOHEADER bmih;
 WORD bits;
 FILE *t24;
 unsigned char *lpBitmapBits;
 long imagesize,nc;
 // read the bitmap
 t24=fopen((char *)fn,"rb");
 if(t24 == NULL){printf("Could not open input file [%s]\n",fn); exit(0);}
 readShortInt(t24);
 bmfh.bfSize=(readLongInt(t24));
 readShortInt(t24);
 readShortInt(t24);
 bmfh.bfOffBits=(readLongInt(t24));
 fread((char *)&bmih,sizeof(BITMAPINFOHEADER),1,t24);
 if(bmih.biClrUsed != 0)nc=bmih.biClrUsed;
 else{
   bits = bmih.biBitCount;
   switch (bits){
     case 1:    nc=2;   break;
     case 4:    nc=16;  break;
     case 8:    nc=256; break;
     default:   nc=0;   break;
   }
 }
 if(nc > 0){printf("Cannot handle paletted image\n"); exit(0);}
 imagesize=bmfh.bfSize-bmfh.bfOffBits;
 if((lpBitmapBits=(unsigned char *)malloc(imagesize)) == NULL){ fclose(t24); exit (0); }
 fread((char *)lpBitmapBits,imagesize,1,t24);
 {
   int i; unsigned char x; for(i=0;i<imagesize;i+=3){
     x = *(lpBitmapBits+i);
	 *(lpBitmapBits+i)= *(lpBitmapBits + i + 2);
	 *(lpBitmapBits+i + 2)= x;
   }
 }
 fclose(t24);
	
#if __APPLE__
#if __INTEL__
 *wi=bmih.biWidth; *hi=bmih.biHeight;
#else	
 *wi=pc2mac(bmih.biWidth); *hi=pc2mac(bmih.biHeight);
#endif	
#else	
 *wi=bmih.biWidth; *hi=bmih.biHeight;
#endif
 return lpBitmapBits;
}
